package tutorial.web;

import java.io.PrintWriter;
import java.io.IOException;
import javax.naming.Context;
import javax.naming.InitialContext;
import javax.naming.NamingException;
import javax.rmi.PortableRemoteObject;
import javax.servlet.ServletConfig;
import javax.servlet.ServletException;
import javax.servlet.http.HttpServlet;
import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;
import tutorial.ejb.Hello;
import tutorial.ejb.HelloHome;

public class HelloServlet extends HttpServlet {

  private HelloHome home = null;

  public void init (ServletConfig config) throws ServletException {
  /* InitialContext̎擾 */
    Context context;
    try {
      context = new InitialContext();
    } catch (NamingException e) {
      throw new ServletException("JNDI InitialContext擾ł܂");
    }
    /* z[EC^tF[X̎擾 */
    try {
      Object boundObject = context.lookup("java:comp/env/ejb/HelloHome");
      home =(HelloHome) PortableRemoteObject.narrow(
                              boundObject, HelloHome.class);
    } catch (NamingException e) {
      throw new ServletException("z[EC^tF[X擾ł܂");
    }
    super.init(config);
  }

  public void doGet(HttpServletRequest request,
                   HttpServletResponse response)
          throws ServletException, IOException {
    String ejbMessage;
    try {
      Hello remote = home.create();   /* [gEC^tF[X̎擾 */
      ejbMessage = remote.sayHello(); /* sayHello\bhs */
    } catch (Exception e) {
      ejbMessage = e.toString();
    }
    /* EJB̏o͌ʂrequestɃZbg */
    request.setAttribute("ejbMessage", ejbMessage);
    /* ʂHTMLƂďo */
    getServletContext().getRequestDispatcher("/helloEJB.jsp").forward(request, response);
  }
}
