import java.io.*;
import java.util.*;
import oracle.portal.provider.v1.*;
import oracle.portal.provider.v1.http.*;

public class HelloWorldCache extends BaseManagedRenderer {

    public void renderBody(PortletRenderRequest pr) throws PortletException {

        try {
            // p[\iCYf[^擾.
            MyPersonalizationObject data = (MyPersonalizationObject)PortletRendererUtil.getEditData(pr);
            // p[\iCYf[^ALbVL[AL擾
            String cacheKey = data.getCacheKey() + "\b";
            String cacheDuration = data.getCacheDuration();

            // LbVLȂLbVgp
            if (isCached(pr, cacheKey, cacheDuration)) {
                HttpPortletRendererUtil.useCachedVersion(pr);
                return;
            }
            // LbV̏ꍇAȍ~̏s
            long currentTime = new Date().getTime();
            HttpPortletRendererUtil.setCachedVersion
                (pr, cacheKey + String.valueOf(currentTime), HttpProvider.USER_LEVEL);

            // ʕ\
            try {
                PrintWriter out = pr.getWriter();
                // p[\iCYbZ[W\.
                out.println(data.getString(MyPersonalizationObject.GREETING));
            }
            catch (IOException ioe) {
                throw new PortletException(ioe);
            }
        } catch (Exception Ex) {
            throw new PortletException(Ex);
        }
        
    }

    // LbV̗L̏
    public static boolean isCached(PortletRenderRequest pr, String cacheKey, String cacheDuration) throws PortletException {
        long currentTime = new Date().getTime();
        String lastCache = HttpPortletRendererUtil.getCachedVersion(pr);
        if (lastCache != null) {
            int keyIndex = lastCache.indexOf("\b") + 1;
            String lastKey = lastCache.substring(0, keyIndex);
            long lastTime;
            try {
                lastTime = Long.parseLong(lastCache.substring(keyIndex));
            } catch(Exception ex) {
            lastTime = 0;
            }
            long cacheDurationLong;
            try {
                cacheDurationLong = Long.parseLong(cacheDuration);
            } catch(Exception ex) {
                cacheDurationLong = 0;
            }
            // LbVL[ŁAݒ肵LȂLbVgp
            if (lastKey.equals(cacheKey) && (currentTime - lastTime) < cacheDurationLong * 60000) {
                return true;
            }
        }
        return false;
    }
}
