import java.util.*;
import oracle.portal.provider.v1.*;
import oracle.portal.provider.v1.http.*;

public class MyPersonalizationObject extends NameValuePersonalizationObject {

    public static final String GREETING = "mpo_greeting";
    public static String CACHE_KEY = "Cache_Key";
    public static String CACHE_DURATION = "Cache_Duration";
    private static final String CACHE_KEY_KEY = "MY_CACHE_KEY";
    private static final String CACHE_DURATION_KEY = "MY_CACHE_DURATION";
    private String mCacheKey;           // LbVL[
    private String mCacheDuration;      // LbVL

    public void init(PortletReference pr) {
        super.init(pr);
        try {
            setPortletTitle("Hello World Portlet");
            putString(GREETING,"<b>Hello World!</b>");
            mCacheKey = CACHE_KEY;
            setCacheKey(mCacheKey);
            mCacheDuration = CACHE_DURATION;
            setCacheDuration(mCacheDuration);
        }
        catch (Exception e){ 
            pr.getProvider().log("init failed: unable to create preferences. " + e.getMessage());
        }
    }
    public String getCacheKey() {
        return getString(CACHE_KEY_KEY);
    }
    public String getCacheDuration() {
        return getString(CACHE_DURATION_KEY);
      }
    public void setCacheKey(String cacheKey) {
        if (cacheKey == null) {
            mCacheKey =  "";
        } else {
            mCacheKey = cacheKey;
        }
        putString(CACHE_KEY_KEY, mCacheKey);
    }
    public void setCacheDuration(String cacheDuration) {
        if (cacheDuration == null) {
            mCacheDuration =  "";
        } else {
            mCacheDuration = cacheDuration;
        }
        putString(CACHE_DURATION_KEY, mCacheDuration);
    }
}
