(p_pr/* @Copyright (c) 1999-2001, Oracle Corporation Japan. All rights reserved. */

-- Sample Hello World Portlet for Oracle Portal 3.0
-- Usage: SQL> @hello_portlet <PROVIDER_SCHEMA>
-- Example: SQL> @hello_portlet scott
-- 2001 08/15 by TH

set verify off
set define on

-- |[gbgEvoC_̃pbP[W쐬XL[}𓮓IɎw
undefine PROVIDER_SCHEMA
define PROVIDER_SCHEMA=&&1

-- |[gbgpbP[ẂuHELLO_PORTLETv
undefine PORTLET_PACKAGE
define PORTLET_PACKAGE=HELLO_PORTLET

create or replace package &&PROVIDER_SCHEMA..&&PORTLET_PACKAGE
is
-- LbVp萔̐ݒ
    CACHE_LEVEL_SYSTEM constant varchar2(10) := 'SYSTEM';
    CACHE_LEVEL_USER   constant varchar2(10) := 'USER';

-- e|[gbgɓKIDӂ
    PORTLET_ID constant integer := 1;
-- |[gbǵuHello_Worldv
    PORTLET_NAME constant varchar2(55) := 'Hello_World';
-- |[gbg̕\́uHello Worldv
    DEFAULT_TITLE constant varchar2(55) := 'Hello World';
-- |[gbg\ftHg̃bZ[W͓ӂ́uHello World!v
    DEFAULT_MESSAGE constant varchar2(256) := 'Hello World!';
-- |[gbg̃ftHg̃LbVL[
    DEFAULT_CACHE_KEY constant varchar2(1) := '0';

-- [U[vt@XXgAp̒萔⃌R[h̒`
-- [U[vt@XXgȀڍׂɂĂPDKQƂ̂
    PORTLET_PATH    constant varchar2(256)
    := 'oracle.portal.sample.portlet.&&PORTLET_PACKAGE';
    DOMAIN          constant varchar2(30) := lower('provider');
    SUBDOMAIN       constant varchar2(32) := lower('&&PORTLET_PACKAGE');
    TITLE_PREF      constant varchar2(256) := PORTLET_NAME || '_TITLE';
    MESSAGE_PREF    constant varchar2(256) := PORTLET_NAME || '_MESSAGE';
    CACHE_PREF      constant varchar2(256) := PORTLET_NAME || '_CACHE';
    CHAR_BS         constant varchar2(1) := chr(8);

    type prefs_record is record
    (
        title_id  varchar2(256),
        title_str varchar2(256),
        msg_id    varchar2(256),
        msg_str   varchar2(256),
        cache_id  varchar2(256),
        cache_str varchar2(55)
    );

    function is_runnable
    (
       p_provider_id in integer,
       p_reference_path in varchar2
    )
    return boolean;

-- w肳ꂽ|[gbgɊւڍ׏Ԃ
    function get_portlet_info
    (
        p_provider_id in integer,
        p_language in varchar2
    )
    return wwpro_api_provider.portlet_record;

-- |[^Ey[WɃ|[gbgǉ鎞Ɉxs
    procedure register
    (
        p_portlet_instance in wwpro_api_provider.portlet_instance_record
    );

-- |[^Ey[W|[gbg폜鎞Ɉxs
    procedure deregister
    (
        p_portlet_instance in wwpro_api_provider.portlet_instance_record
    );

-- |[gbgo͂HTMLԂ
-- HTML̓e|[^Ey[W̃|[gbgƂċ@\
    procedure show
    (
        p_portlet_record in out wwpro_api_provider.portlet_runtime_record
    );

-- |[gbg̃JX^}CYʂŁuOKv{^NbNƎsA
-- ftHg̃JX^}CYۑ
    procedure save_default_prefs
    (
        p_title_str      in varchar2,
        p_msg_str        in varchar2,
        p_cache_str      in varchar2,
        p_back_url       in varchar2,
        p_page_url       in varchar2,
        p_reference_path in varchar2,
        p_language       in varchar2,
        p_action         in varchar2,
        p_request        in varchar2 default null
    );

-- |[gbg̃JX^}CYʂŁuOKv{^NbNƎsA
-- [U[̃JX^}CY[U[vt@XXgAɕۑ
    procedure save_prefs
    (
        p_title_str      in varchar2,
        p_msg_str        in varchar2,
        p_cache_str      in varchar2,
        p_back_url       in varchar2,
        p_page_url       in varchar2,
        p_reference_path in varchar2,
        p_language       in varchar2,
        p_action         in varchar2,
        p_request        in varchar2 default null
    );
end &&PORTLET_PACKAGE;
/

show errors package &&PROVIDER_SCHEMA..&&PORTLET_PACKAGE;

create or replace package body &&PROVIDER_SCHEMA..&&PORTLET_PACKAGE
is
    function is_runnable
    (
       p_provider_id in integer,
       p_reference_path in varchar2
    )
    return boolean is
    begin
        if p_reference_path is null then
            if wwctx_api.is_logged_on then
                return true;
            else
                return false;
            end if;
        else
            return true;
        end if;
    end is_runnable;

    function get_portlet_info
    (
        p_provider_id in integer,
        p_language in varchar2
    )
    return wwpro_api_provider.portlet_record is
        l_portlet wwpro_api_provider.portlet_record;
    begin
        l_portlet.timeout := null;
        l_portlet.timeout_msg := null;
        l_portlet.implementation_style :=
        wwpro_api_provider_registry.DATABASE_IMPL;
        l_portlet.implementation_owner := '&&PROVIDER_SCHEMA';
        l_portlet.implementation_name := '&&PORTLET_PACKAGE';
        l_portlet.api_version := wwpro_api_provider.API_VERSION_1;
        l_portlet.has_show_edit_defaults := true;
        l_portlet.has_show_preview := true;
        l_portlet.language := wwctx_api.get_nls_language;
        l_portlet.content_type := wwpro_api_provider.CONTENT_TYPE_HTML;
        l_portlet.id := PORTLET_ID;
        l_portlet.name := PORTLET_NAME;
        l_portlet.title := DEFAULT_TITLE;
        l_portlet.description := DEFAULT_TITLE;

        return l_portlet;
    end get_portlet_info;

    function get_default_prefs
    (
        p_reference_path in varchar2,
        p_language in varchar2
    )
    return prefs_record
    is
        l_prefs prefs_record;
    begin
        begin
            l_prefs.title_id := to_char(wwpre_api_value.get_value_as_number(
                p_path => PORTLET_PATH || p_reference_path,
                p_name => TITLE_PREF,
                p_level_type => wwpre_api_value.SYSTEM_LEVEL_TYPE));
            exception
                when others then
                    l_prefs.title_id := null;
        end;

        if l_prefs.title_id is null or to_number(l_prefs.title_id) = 0 then
            l_prefs.title_str := DEFAULT_TITLE;
        else
            l_prefs.title_str := substr(wwnls_api.get_string(
            to_number(l_prefs.title_id), wwctx_api.get_nls_language), 1, 256);
        end if;

        begin
            l_prefs.msg_id := to_char(wwpre_api_value.get_value_as_number(
                p_path => PORTLET_PATH || p_reference_path,
                p_name => MESSAGE_PREF,
                p_level_type => wwpre_api_value.SYSTEM_LEVEL_TYPE));
            exception
                when others then
                    l_prefs.msg_id := null;
        end;

        if l_prefs.msg_id is null or to_number(l_prefs.msg_id) = 0 then
            l_prefs.msg_str := DEFAULT_MESSAGE;
        else
            l_prefs.msg_str := substr(wwnls_api.get_string(
            to_number(l_prefs.msg_id), wwctx_api.get_nls_language), 1, 256);
        end if;

        begin
            l_prefs.cache_id := to_char(wwpre_api_value.get_value_as_number(
                p_path => PORTLET_PATH || p_reference_path,
                p_name => CACHE_PREF,
                p_level_type => wwpre_api_value.SYSTEM_LEVEL_TYPE));
            exception
                when others then
                    l_prefs.cache_id := null;
        end;

        if l_prefs.cache_id is null or to_number(l_prefs.cache_id) = 0 then
            l_prefs.cache_str := DEFAULT_CACHE_KEY;
        else
            l_prefs.cache_str := substr(wwnls_api.get_string(
            to_number(l_prefs.cache_id), wwctx_api.get_nls_language), 1, 55);
        end if;

        return l_prefs;
    end;

    function get_prefs
    (
        p_reference_path in varchar2,
        p_language in varchar2
    )
    return prefs_record
    is
        l_prefs prefs_record;
    begin
        begin
            l_prefs.title_str := wwpre_api_value.get_value_as_varchar2(
                p_path => PORTLET_PATH || p_reference_path,
                p_name => TITLE_PREF,
                p_level_type => wwpre_api_value.USER_LEVEL_TYPE,
                p_level_name => wwctx_api.get_user);
            exception
                when others then
                    l_prefs.title_str := null;
        end;

        begin
            l_prefs.msg_str := wwpre_api_value.get_value_as_varchar2(
                p_path => PORTLET_PATH || p_reference_path,
                p_name => MESSAGE_PREF,
                p_level_type => wwpre_api_value.USER_LEVEL_TYPE,
                p_level_name => wwctx_api.get_user);
            exception
                when others then
                    l_prefs.msg_str := null;
        end;

        begin
            l_prefs.cache_str := wwpre_api_value.get_value_as_varchar2(
                p_path => PORTLET_PATH || p_reference_path,
                p_name => CACHE_PREF,
                p_level_type => wwpre_api_value.USER_LEVEL_TYPE,
                p_level_name => wwctx_api.get_user);
            exception
                when others then
                    l_prefs.cache_str := null;
        end;

        if l_prefs.title_str is null or l_prefs.msg_str is null
        or l_prefs.cache_str is null then
            l_prefs := get_default_prefs(p_reference_path => p_reference_path,
                                         p_language => p_language);
        end if;

        if l_prefs.title_str = CHAR_BS then
            l_prefs.title_str := null;
        end if;

        if l_prefs.msg_str = CHAR_BS then
            l_prefs.msg_str := null;
        end if;

        if l_prefs.cache_str = CHAR_BS then
            l_prefs.cache_str := null;
        end if;

        return l_prefs;
    end;

    procedure register
    (
        p_portlet_instance in wwpro_api_provider.portlet_instance_record
    )
    is
    begin
        begin
            wwpre_api_name.create_path(p_path => PORTLET_PATH || p_portlet_instance.reference_path);
        exception when wwpre_api_name.duplicate_path_exception then
            null;
        end;

        wwpre_api_name.create_name(
            p_path => PORTLET_PATH || p_portlet_instance.reference_path,
            p_name => TITLE_PREF,
            p_description => TITLE_PREF,
            p_type_name => 'NLSID',
            p_language => wwctx_api.get_nls_language);

        wwpre_api_name.create_name(
            p_path => PORTLET_PATH || p_portlet_instance.reference_path,
            p_name => MESSAGE_PREF,
            p_description => MESSAGE_PREF,
            p_type_name => 'NLSID',
            p_language => wwctx_api.get_nls_language);

        wwpre_api_name.create_name(
            p_path => PORTLET_PATH || p_portlet_instance.reference_path,
            p_name => CACHE_PREF,
            p_description => CACHE_PREF,
            p_type_name => 'NLSID',
            p_language => wwctx_api.get_nls_language);
    exception
        when others then
            raise;
    end register;

    procedure deregister
    (
        p_portlet_instance in wwpro_api_provider.portlet_instance_record
    )
    is
        l_prefs prefs_record;
        i number;
    begin
        l_prefs := get_default_prefs(p_reference_path => p_portlet_instance.reference_path,
                                     p_language => wwctx_api.get_nls_language);
        begin
            if l_prefs.title_id is not null and to_number(l_prefs.title_id) <> 0 then
                i := wwnls_api.remove_string(to_number(l_prefs.title_id), true);
            end if;

            if l_prefs.msg_id is not null and to_number(l_prefs.msg_id) <> 0 then
                i := wwnls_api.remove_string(to_number(l_prefs.msg_id), true);
            end if;

            if l_prefs.cache_id is not null and to_number(l_prefs.cache_id) <> 0 then
                i := wwnls_api.remove_string(to_number(l_prefs.cache_id), true);
            end if;

            wwpre_api_name.delete_path(PORTLET_PATH || p_portlet_instance.reference_path);
        exception
            when others then
                 null;
        end;
    end deregister;

    procedure script_open
    (
        version varchar2 default '1.1',
        source  varchar2 default null
    )
    is
    begin
        if source is not null then
            htp.p('<SCRIPT LANGUAGE="JavaScript' || version || '" SRC="' || source || '">');
        else
            htp.p('<SCRIPT LANGUAGE="JavaScript' || version || '">');
        end if;
    end script_open;

    procedure script_close
    is
    begin
        htp.p('</SCRIPT>');
    end script_close;

    procedure edit_default_prefs(
        p_back_url in varchar2,
        p_page_url in varchar2,
        p_reference_path in varchar2,
        p_language in varchar2
    )
    is
        l_ok wwui_api_portlet_dialog.button;
        l_apply wwui_api_portlet_dialog.button;
        l_cancel wwui_api_portlet_dialog.button;
        l_buttons wwui_api_portlet_dialog.button_list;
        l_title varchar2(256) := '';
        l_prefs prefs_record;
    begin
        l_prefs := get_default_prefs(p_reference_path => p_reference_path,
                                     p_language => p_language);

        script_open;
        htp.p('function Save(pAction) {');
        htp.p('    document.' || PORTLET_NAME || '_form.p_action.value = pAction;');
        htp.p('    document.' || PORTLET_NAME || '_form.submit();}');
        script_close;

        htp.formopen(curl => '&&PROVIDER_SCHEMA..&&PORTLET_PACKAGE..save_default_prefs',
                     cattributes => 'NAME="' || PORTLET_NAME || '_form"');

        l_title := DEFAULT_TITLE || ' ̃ftHg̃JX^}CY̕ҏW';

        l_ok := wwui_api_portlet_dialog.create_ok_button('Save(''finish'')');
        l_apply := wwui_api_portlet_dialog.create_apply_button('Save(''apply'')');
        l_cancel := wwui_api_portlet_dialog.create_cancel_button('Save(''cancel'')');
        l_buttons(1) := l_ok;
        l_buttons(2) := l_apply;
        l_buttons(3) := l_cancel;

        wwui_api_portlet_dialog.open_dialog(
            p_title => l_title,
            p_dialog_image => wwctx_api.get_image_path||'w_128x52.jpg',
            p_buttons => l_buttons,
            p_help_url  => 'http://technet.oracle.co.jp');

        htp.formHidden('p_action', '');
        htp.formHidden('p_back_url', p_back_url);
        htp.formHidden('p_page_url', p_page_url);
        htp.formHidden('p_reference_path', p_reference_path);
        htp.formHidden('p_language', p_language);
        htp.formHidden('p_cache_str', l_prefs.cache_str);

        htp.centeropen;
        htp.tableOpen(cattributes => 'WIDTH=90%');
        htp.tableRowOpen;
        htp.tableData('<b>ftHg̃^Cg͂ĉ</b>');
        htp.tableRowClose;
        htp.tableRowOpen;
        htp.tableData(htf.formtext('p_title_str', 55, 256, l_prefs.title_str));
        htp.tableRowClose;
        htp.tableRowOpen;
        htp.tableData('<b>ftHg̃bZ[W͂ĉ</b>');
        htp.tableRowClose;
        htp.tableRowOpen;
        htp.tableData(htf.formtext('p_msg_str', 55, 256, l_prefs.msg_str));
        htp.tableRowClose;
        htp.tableClose;
        htp.centerclose;

        wwui_api_portlet_dialog.close_dialog;
        htp.formclose;
    end;

    procedure edit_prefs(
        p_back_url in varchar2,
        p_page_url in varchar2,
        p_reference_path in varchar2,
        p_language in varchar2
    )
    is
        l_ok wwui_api_portlet_dialog.button;
        l_apply wwui_api_portlet_dialog.button;
        l_cancel wwui_api_portlet_dialog.button;
        l_buttons wwui_api_portlet_dialog.button_list;
        l_title varchar2(256) := '';
        l_prefs prefs_record;
    begin
        l_prefs := get_prefs(p_reference_path => p_reference_path, p_language => p_language);

        script_open;
        htp.p('function Save(pAction) {');
        htp.p('    document.' || PORTLET_NAME || '_form.p_action.value = pAction;');
        htp.p('    document.' || PORTLET_NAME || '_form.submit();}');
        script_close;

        htp.formopen(curl => '&&PROVIDER_SCHEMA..&&PORTLET_PACKAGE..save_prefs',
                     cattributes => 'NAME="' || PORTLET_NAME || '_form"');

        l_title := l_prefs.title_str || ' ̃JX^}CY̕ҏW';

        l_ok := wwui_api_portlet_dialog.create_ok_button('Save(''finish'')');
        l_apply := wwui_api_portlet_dialog.create_apply_button('Save(''apply'')');
        l_cancel := wwui_api_portlet_dialog.create_cancel_button('Save(''cancel'')');
        l_buttons(1) := l_ok;
        l_buttons(2) := l_apply;
        l_buttons(3) := l_cancel;

        wwui_api_portlet_dialog.open_dialog(
            p_title => l_title,
            p_dialog_image => wwctx_api.get_image_path||'w_128x52.jpg',
            p_buttons => l_buttons,
            p_help_url  => 'http://technet.oracle.co.jp');

        htp.formHidden('p_action', '');
        htp.formHidden('p_back_url', p_back_url);
        htp.formHidden('p_page_url', p_page_url);
        htp.formHidden('p_reference_path', p_reference_path);
        htp.formHidden('p_language', p_language);
        htp.formHidden('p_cache_str', l_prefs.cache_str);

        htp.centeropen;
        htp.tableOpen(cattributes => 'WIDTH=90%');
        htp.tableRowOpen;
        htp.tableData('<b>^Cg͂ĉ</b>');
        htp.tableRowClose;
        htp.tableRowOpen;
        htp.tableData(htf.formtext('p_title_str', 55, 256, l_prefs.title_str));
        htp.tableRowClose;
        htp.tableRowOpen;
        htp.tableData('<b>bZ[W͂ĉ</b>');
        htp.tableRowClose;
        htp.tableRowOpen;
        htp.tableData(htf.formtext('p_msg_str', 55, 256, l_prefs.msg_str));
        htp.tableRowClose;
        htp.tableClose;
        htp.centerclose;

        wwui_api_portlet_dialog.close_dialog;
        htp.formclose;
    end;

    procedure save_default_prefs
    (
        p_title_str      in varchar2,
        p_msg_str        in varchar2,
        p_cache_str      in varchar2,
        p_back_url       in varchar2,
        p_page_url       in varchar2,
        p_reference_path in varchar2,
        p_language       in varchar2,
        p_action         in varchar2,
        p_request        in varchar2 default null
    )
    is
        l_prefs prefs_record;
        l_cache_key number;
    begin
        if (p_action = 'finish') or (p_action = 'apply') then
            l_prefs := get_default_prefs(p_reference_path => p_reference_path,
                                         p_language => p_language);

            if l_prefs.title_id is null or to_number(l_prefs.title_id) = 0 then
                l_prefs.title_id := wwnls_api.add_string(
                    p_domain => DOMAIN,
                    p_sub_domain => SUBDOMAIN,
                    p_name => TITLE_PREF || p_reference_path,
                    p_language => p_language,
                    p_text => p_title_str);

                wwpre_api_value.set_value_as_number(
                    p_path => PORTLET_PATH || p_reference_path,
                    p_name => TITLE_PREF,
                    p_level_type => wwpre_api_value.SYSTEM_LEVEL_TYPE,
                    p_level_name => null,
                    p_value => l_prefs.title_id);
            else
                wwnls_api.set_string(
                    p_id => to_number(l_prefs.title_id),
                    p_language => p_language,
                    p_text => p_title_str);
            end if;

            if l_prefs.msg_id is null or to_number(l_prefs.msg_id) = 0 then
                l_prefs.msg_id := wwnls_api.add_string(
                    p_domain => DOMAIN,
                    p_sub_domain => SUBDOMAIN,
                    p_name => MESSAGE_PREF || p_reference_path,
                    p_language => p_language,
                    p_text => p_msg_str);

                wwpre_api_value.set_value_as_number(
                    p_path => PORTLET_PATH || p_reference_path,
                    p_name => MESSAGE_PREF,
                    p_level_type => wwpre_api_value.SYSTEM_LEVEL_TYPE,
                    p_level_name => null,
                    p_value => l_prefs.msg_id);
            else
                wwnls_api.set_string(
                    p_id => to_number(l_prefs.msg_id),
                    p_language => p_language,
                    p_text => p_msg_str);
            end if;

            l_cache_key := to_number(p_cache_str) + 1;

            if l_cache_key <= 99999999 then
                l_prefs.cache_str := to_char(l_cache_key);
            else
                l_prefs.cache_str := 0;
            end if;

            if l_prefs.cache_id is null or to_number(l_prefs.cache_id) = 0 then
                l_prefs.cache_id := wwnls_api.add_string(
                    p_domain => DOMAIN,
                    p_sub_domain => SUBDOMAIN,
                    p_name => CACHE_PREF || p_reference_path,
                    p_language => p_language,
                    p_text => l_prefs.cache_str);

                wwpre_api_value.set_value_as_number(
                    p_path => PORTLET_PATH || p_reference_path,
                    p_name => CACHE_PREF,
                    p_level_type => wwpre_api_value.SYSTEM_LEVEL_TYPE,
                    p_level_name => null,
                    p_value => l_prefs.cache_id);
            else
                wwnls_api.set_string(
                    p_id => to_number(l_prefs.cache_id),
                    p_language => p_language,
                    p_text => l_prefs.cache_str);
            end if;
        end if;

        if p_action = 'apply' then
            owa_util.redirect_url(curl => p_page_url);
        else
            owa_util.redirect_url(curl => p_back_url);
        end if;
    end;

    procedure save_prefs
    (
        p_title_str      in varchar2,
        p_msg_str        in varchar2,
        p_cache_str      in varchar2,
        p_back_url       in varchar2,
        p_page_url       in varchar2,
        p_reference_path in varchar2,
        p_language       in varchar2,
        p_action         in varchar2,
        p_request        in varchar2 default null
    )
    is
        l_prefs prefs_record;
        l_cache_key number;
    begin
        if (p_action = 'finish') or (p_action = 'apply') then
            if p_title_str is null then
                l_prefs.title_str := CHAR_BS;
            else
                l_prefs.title_str := p_title_str;
            end if;

            wwpre_api_value.set_value_as_varchar2(
                p_path => PORTLET_PATH || p_reference_path,
                p_name => TITLE_PREF,
                p_level_type => wwpre_api_value.USER_LEVEL_TYPE,
                p_level_name => wwctx_api.get_user,
                p_value => l_prefs.title_str);

            if p_msg_str is null then
                l_prefs.msg_str := CHAR_BS;
            else
                l_prefs.msg_str := p_msg_str;
            end if;

            wwpre_api_value.set_value_as_varchar2(
                p_path => PORTLET_PATH || p_reference_path,
                p_name => MESSAGE_PREF,
                p_level_type => wwpre_api_value.USER_LEVEL_TYPE,
                p_level_name => wwctx_api.get_user,
                p_value => l_prefs.msg_str);

            l_cache_key := to_number(p_cache_str) + 1;

            if l_cache_key <= 99999999 then
                l_prefs.cache_str := to_char(l_cache_key);
            else
                l_prefs.cache_str := 0;
            end if;

            wwpre_api_value.set_value_as_varchar2(
                p_path => PORTLET_PATH || p_reference_path,
                p_name => CACHE_PREF,
                p_level_type => wwpre_api_value.USER_LEVEL_TYPE,
                p_level_name => wwctx_api.get_user,
                p_value => l_prefs.cache_str);
         end if;

        if p_action = 'apply' then
            owa_util.redirect_url(curl => p_page_url);
        else
            owa_util.redirect_url(curl => p_back_url);
        end if;
    end;

    procedure show_details
    (
        p_back_url in varchar2,
        p_page_url in varchar2,
        p_reference_path in varchar2,
        p_language in varchar2
    )
    is
        l_prefs prefs_record;
    begin
        l_prefs := get_prefs(p_reference_path => p_reference_path,
                             p_language => p_language);

        htp.centeropen;
        htp.p('<BR><FONT COLOR=Red><STRONG>'
           || l_prefs.msg_str
           || '</STRONG></FONT><P>');
        htp.p('<A HREF="' || p_back_url || '">NbNƌ̃y[Wɖ߂܂</A><P>');
        htp.centerclose;
    end;

    procedure show_help
    (
        p_back_url in varchar2
    )
    is
    begin
        htp.centeropen;
        htp.p('<BR><FONT COLOR=Red><STRONG>'
           || 'wv̕\'
           || '</STRONG></FONT><P>'
           || ':uJX^}CYvNNbN<BR>'
           || '\郁bZ[WύXł܂<P>');
        htp.p('<A HREF="' || p_back_url || '">NbNƌ̃y[Wɖ߂܂</A><P>');
        htp.centerclose;
    end;

    procedure show_about
    (
        p_back_url in varchar2
    )
    is
    begin
        htp.centeropen;
        htp.p('<BR><FONT COLOR=Red><STRONG>'
           || '|[gbg̃o[W⒘쌠\'
           || '</STRONG></FONT><P>'
           || ': Hello World Portlet Ver. 1.1 (Portal 3.0p)<BR>'
           || 'Copyright (c) 2000-2001, Oracle Corporation Japan. All rights reserved.<P>');
        htp.p('<A HREF="' || p_back_url || '">NbNƌ̃y[Wɖ߂܂</A><P>');
        htp.centerclose;
    end;

    procedure show
    (
        p_portlet_record in out wwpro_api_provider.portlet_runtime_record
    )
    is
        l_prefs prefs_record;
    begin
        if not is_runnable(p_provider_id => p_portlet_record.provider_id,
                           p_reference_path => p_portlet_record.reference_path) then
            p_portlet_record.caching_level := null;
            p_portlet_record.caching_key := null;

            wwerr_api_error.add(DOMAIN, SUBDOMAIN, 'securityerr', PORTLET_NAME || '.show'); 
            raise wwpro_api_provider.PORTLET_SECURITY_EXCEPTION;
        end if;

        l_prefs := get_prefs(p_reference_path => p_portlet_record.reference_path,
                             p_language => p_portlet_record.language);

        if p_portlet_record.caching_level = CACHE_LEVEL_SYSTEM then
            if l_prefs.cache_str is not null then
                p_portlet_record.caching_level := CACHE_LEVEL_USER;
                p_portlet_record.caching_key := l_prefs.cache_str;
            else
                return;
            end if;
        elsif p_portlet_record.caching_level = CACHE_LEVEL_USER then
            if p_portlet_record.caching_key <> l_prefs.cache_str then
                p_portlet_record.caching_key := l_prefs.cache_str;
            else
                return;
            end if;
        elsif p_portlet_record.caching_level is null then
            if p_portlet_record.caching_key is not null then
                p_portlet_record.caching_level := CACHE_LEVEL_USER;
                p_portlet_record.caching_key := l_prefs.cache_str;
            else
                p_portlet_record.caching_level := CACHE_LEVEL_SYSTEM;
                p_portlet_record.caching_key := l_prefs.cache_str;
            end if;
        else
            p_portlet_record.caching_level := CACHE_LEVEL_SYSTEM;
            p_portlet_record.caching_key := l_prefs.cache_str;
        end if;

        if p_portlet_record.exec_mode = wwpro_api_provider.MODE_SHOW then
            if p_portlet_record.has_title_region then
                wwui_api_portlet.draw_portlet_header(
                    p_provider_id       => p_portlet_record.provider_id,
                    p_portlet_id        => p_portlet_record.portlet_id,
                    p_title             => l_prefs.title_str,
                    p_has_details       => true,
                    p_has_edit          => true,
                    p_has_help          => true,
                    p_has_about         => true,
                    p_back_url          => p_portlet_record.page_url,
                    p_referencepath     => p_portlet_record.reference_path);
            end if;

            wwui_api_portlet.open_portlet(p_has_border => p_portlet_record.has_border);
            htp.centeropen;
            htp.p('<BR><FONT COLOR=Red><STRONG>'
               || l_prefs.msg_str
               || '</STRONG></FONT><BR>');
            htp.centerclose;
            wwui_api_portlet.close_portlet;
        elsif p_portlet_record.exec_mode = wwpro_api_provider.MODE_PREVIEW then
            htp.centeropen;
            htp.p('<BR><FONT COLOR=Red><STRONG>'
               || DEFAULT_MESSAGE
               || '</STRONG></FONT><BR>');
            htp.centerclose;
        elsif p_portlet_record.exec_mode = wwpro_api_provider.MODE_SHOW_DETAILS then
            show_details(
                p_back_url => p_portlet_record.back_page_url,
                p_page_url => p_portlet_record.page_url,
                p_reference_path => p_portlet_record.reference_path,
                p_language => p_portlet_record.language);
        elsif p_portlet_record.exec_mode = wwpro_api_provider.MODE_SHOW_EDIT_DEFAULTS then
            edit_default_prefs(
                p_back_url => p_portlet_record.back_page_url,
                p_page_url => p_portlet_record.page_url,
                p_reference_path => p_portlet_record.reference_path,
                p_language => p_portlet_record.language);
        elsif p_portlet_record.exec_mode = wwpro_api_provider.MODE_SHOW_EDIT then
            edit_prefs(
                p_back_url => p_portlet_record.back_page_url,
                p_page_url => p_portlet_record.page_url,
                p_reference_path => p_portlet_record.reference_path,
                p_language => p_portlet_record.language);
        elsif p_portlet_record.exec_mode = wwpro_api_provider.MODE_SHOW_HELP then
            show_help(p_portlet_record.back_page_url);
        elsif p_portlet_record.exec_mode = wwpro_api_provider.MODE_SHOW_ABOUT then
            show_about(p_portlet_record.back_page_url);
        else
            raise wwpro_api_provider.PORTLET_EXECUTION_EXCEPTION;
        end if;
    end show;
end &&PORTLET_PACKAGE;
/

show errors package body &&PROVIDER_SCHEMA..&&PORTLET_PACKAGE;
grant execute on &&PROVIDER_SCHEMA..&&PORTLET_PACKAGE to public;
commit;
exit
