(p_pr/* @Copyright (c) 1999-2001, Oracle Corporation Japan. All rights reserved. */

-- Sample Hello World Portlet Provider for Oracle Portal 3.0
-- Usage: SQL> @hello_provider <PROVIDER_SCHEMA>
-- Example: SQL> @hello_provider scott
-- 2001 08/15 by TH

set verify off
set define on

-- |[gbgEvoC_̃pbP[W쐬XL[}𓮓IɎw
undefine PROVIDER_SCHEMA
define PROVIDER_SCHEMA=&&1

-- |[gbgEvoC_pbP[ẂuHELLO_PROVIDERv
undefine PROVIDER_PACKAGE
define PROVIDER_PACKAGE=HELLO_PROVIDER

-- |[gbg1pbP[ẂuHELLO_PORTLETv
undefine PORTLET1_PACKAGE
define PORTLET1_PACKAGE=HELLO_PORTLET

-- |[gbg2pbP[ẂuORACLE_PORTLETv
undefine PORTLET2_PACKAGE
define PORTLET2_PACKAGE=ORACLE_PORTLET

create or replace package &&PROVIDER_SCHEMA..&&PROVIDER_PACKAGE
is
-- voC_API̎:pbP[Wdl

-- Help܂AboutȂǂ̃voC_Ex\
    procedure show
    (
        p_language in varchar2,
        p_mode in integer
    );

-- KvȔF؁AуZbṼZbgAbvs
    procedure do_login
    (
        p_provider_id in integer,
        p_browser_cookies in wwpro_api_provider.cookie_table,
        p_provider_cookies out wwpro_api_provider.cookie_table
    );

-- voC_APĨo[WԂ(Oracle Portal 3.0ł͏1Ԃ)
    function get_api_version
    return integer;

-- |[gbggpp[^Ԃ
    function describe_portlet_parameters
    (
        p_provider_id in integer,
        p_portlet_id in integer,
        p_language in varchar2
    )
    return wwpro_api_provider.portlet_parameter_table;

-- w肳ꂽ|[gbgs\ǂԂ
    function is_portlet_runnable
    (
        p_portlet_instance in wwpro_api_provider.portlet_instance_record
    )
    return boolean;

-- w肳ꂽ|[gbgɊւڍ׏Ԃ
    function get_portlet
    (
        p_provider_id in integer,
        p_portlet_id  in integer,
        p_language    in varchar2
    )
    return wwpro_api_provider.portlet_record;

-- ̃voC_Ǘ|[gbg̃XgԂ
    function get_portlet_list
    (
        p_provider_id    in integer,
        p_start_row      in integer,
        p_row_count      in integer,
        p_language       in varchar2,
        p_security_level in boolean default true,
        p_type           in integer default wwpro_api_provider.LIST_PORTLET
    )
    return wwpro_api_provider.portlet_table;

-- |[^Ey[WɃ|[gbgǉ鎞Ɉxs
    procedure register_portlet
    (
        p_portlet_instance in wwpro_api_provider.portlet_instance_record
    );

-- |[^Ey[W|[gbg폜鎞Ɉxs
    procedure deregister_portlet
    (
        p_portlet_instance in wwpro_api_provider.portlet_instance_record
    );

-- |[^Ƀ|[gbgEvoC_ǉ鎞Ɉxs
    procedure register_provider
    (
        p_provider_id in integer
    );

-- |[^|[gbgEvoC_폜鎞Ɉxs
    procedure deregister_provider
    (
        p_provider_id in integer
    );

--  |[^Ey[WRs[鎞ɁAKvł΃JX^}CY
--  [U[vt@XXgAɕۑ
    procedure copy_portlet
    (
        p_copy_portlet_info in wwpro_api_provider.copy_portlet_record
    );

-- |[gbgo͂HTMLԂ
-- HTML̓e|[^Ey[W̃|[gbgƂċ@\
    procedure show_portlet
    (
        p_portlet_record in out wwpro_api_provider.portlet_runtime_record
    );
end &&PROVIDER_PACKAGE;
/

show errors package &&PROVIDER_SCHEMA..&&PROVIDER_PACKAGE;

create or replace package body &&PROVIDER_SCHEMA..&&PROVIDER_PACKAGE
is
-- voC_API̎:pbP[W{̕
    procedure show
    (
        p_language in varchar2,
        p_mode in integer
    )
    is
    begin
        htp.p('Insert HTML Designtime interfaces here :)');
    end show;

    procedure do_login
    (
        p_provider_id in integer,
        p_browser_cookies in wwpro_api_provider.cookie_table,
        p_provider_cookies out wwpro_api_provider.cookie_table
    )
    is
    begin
        null;
    end do_login;

    function get_api_version
    return integer is
    begin
        return wwpro_api_provider.API_VERSION_1;
    end get_api_version;

    function describe_portlet_parameters
    (
        p_provider_id in integer,
        p_portlet_id in integer,
        p_language in varchar2
    )
    return wwpro_api_provider.portlet_parameter_table is
        l_params wwpro_api_provider.portlet_parameter_table;
    begin
        return l_params;
    end describe_portlet_parameters;

    function is_portlet_runnable
    (
        p_portlet_instance in wwpro_api_provider.portlet_instance_record
    )
    return boolean is
    begin
        if p_portlet_instance.portlet_id = &&PORTLET1_PACKAGE..PORTLET_ID then
            return &&PORTLET1_PACKAGE..is_runnable(p_provider_id => p_portlet_instance.provider_id,
                                                   p_reference_path => p_portlet_instance.reference_path);
        elsif p_portlet_instance.portlet_id = &&PORTLET2_PACKAGE..PORTLET_ID then
            return &&PORTLET2_PACKAGE..is_runnable(p_provider_id => p_portlet_instance.provider_id,
                                                   p_reference_path => p_portlet_instance.reference_path);
        end if;
    end is_portlet_runnable;

    function get_portlet
    (
        p_provider_id in integer,
        p_portlet_id  in integer,
        p_language    in varchar2
    )
    return wwpro_api_provider.portlet_record is
        l_portlet wwpro_api_provider.portlet_record;
    begin
        if p_portlet_id = &&PORTLET1_PACKAGE..PORTLET_ID then
            return &&PORTLET1_PACKAGE..get_portlet_info(p_provider_id => p_provider_id,
                                                        p_language => p_language);
        elsif p_portlet_id = &&PORTLET2_PACKAGE..PORTLET_ID then
            return &&PORTLET2_PACKAGE..get_portlet_info(p_provider_id => p_provider_id,
                                                        p_language => p_language);
        else
            raise wwpro_api_provider.PORTLET_NOT_FOUND_EXCEPTION;
        end if;
    end get_portlet;

-- dvvoC_API 3
    function get_portlet_list
    (
        p_provider_id    in integer,
        p_start_row      in integer,
        p_row_count      in integer,
        p_language       in varchar2,
        p_security_level in boolean default true,
        p_type           in integer default wwpro_api_provider.LIST_PORTLET
    )
    return wwpro_api_provider.portlet_table is
        l_portlet_list wwpro_api_provider.portlet_table;
        l_cnt number;
    begin
        l_cnt := 0;

        if p_security_level = false then
            l_cnt := l_cnt + 1;
            l_portlet_list(l_cnt) := get_portlet(p_provider_id => p_provider_id,
                                                 p_portlet_id => &&PORTLET1_PACKAGE..PORTLET_ID,
                                                 p_language => p_language);
            l_cnt := l_cnt + 1;
            l_portlet_list(l_cnt) := get_portlet(p_provider_id => p_provider_id,
                                                 p_portlet_id => &&PORTLET2_PACKAGE..PORTLET_ID,
                                                 p_language => p_language);
        else
            if &&PORTLET1_PACKAGE..is_runnable(p_provider_id => p_provider_id,
                                               p_reference_path => null) then
                l_cnt := l_cnt + 1;
                l_portlet_list(l_cnt) := get_portlet(p_provider_id => p_provider_id,
                                                     p_portlet_id => &&PORTLET1_PACKAGE..PORTLET_ID,
                                                     p_language => p_language);
            end if;

            if &&PORTLET2_PACKAGE..is_runnable(p_provider_id => p_provider_id,
                                               p_reference_path => null) then
                l_cnt := l_cnt + 1;
                l_portlet_list(l_cnt) := get_portlet(p_provider_id => p_provider_id,
                                                     p_portlet_id => &&PORTLET2_PACKAGE..PORTLET_ID,
                                                     p_language => p_language);
            end if;
        end if;

        return l_portlet_list;
    end get_portlet_list;

    procedure register_provider
    (
        p_provider_id in integer
    )
    is
    begin
        null;
    end register_provider;

    procedure deregister_provider
    (
        p_provider_id in integer
    )
    is
    begin
        null;
    end deregister_provider;

    procedure register_portlet
    (
        p_portlet_instance in wwpro_api_provider.portlet_instance_record
    )
    is
    begin
        if (p_portlet_instance.portlet_id = &&PORTLET1_PACKAGE..PORTLET_ID) then
            &&PORTLET1_PACKAGE..register(p_portlet_instance);
        elsif (p_portlet_instance.portlet_id = &&PORTLET2_PACKAGE..PORTLET_ID) then
            &&PORTLET2_PACKAGE..register(p_portlet_instance);
        else
            raise wwpro_api_provider.PORTLET_NOT_FOUND_EXCEPTION;
        end if;
    end register_portlet;

    procedure deregister_portlet
    (
        p_portlet_instance in wwpro_api_provider.portlet_instance_record
    )
    is
    begin
        if (p_portlet_instance.portlet_id = &&PORTLET1_PACKAGE..PORTLET_ID) then
            &&PORTLET1_PACKAGE..deregister(p_portlet_instance);
        elsif (p_portlet_instance.portlet_id = &&PORTLET2_PACKAGE..PORTLET_ID) then
            &&PORTLET2_PACKAGE..deregister(p_portlet_instance);
        else
            raise wwpro_api_provider.PORTLET_NOT_FOUND_EXCEPTION;
        end if;
    end deregister_portlet;

    procedure copy_portlet
    (
        p_copy_portlet_info in wwpro_api_provider.copy_portlet_record
    )
    is
    begin
        null;
    end copy_portlet;

    procedure show_portlet
    (
        p_portlet_record in out wwpro_api_provider.portlet_runtime_record
    )
    is
    begin
        if (p_portlet_record.portlet_id = &&PORTLET1_PACKAGE..PORTLET_ID) then
            &&PORTLET1_PACKAGE..show(p_portlet_record);
        elsif (p_portlet_record.portlet_id = &&PORTLET2_PACKAGE..PORTLET_ID) then
            &&PORTLET2_PACKAGE..show(p_portlet_record);
        else
            raise wwpro_api_provider.PORTLET_NOT_FOUND_EXCEPTION;
        end if;
    end show_portlet;
end &&PROVIDER_PACKAGE;
/

show errors package body &&PROVIDER_SCHEMA..&&PROVIDER_PACKAGE;
grant execute on &&PROVIDER_SCHEMA..&&PROVIDER_PACKAGE to public;
commit;
exit
