(p_pr/* @Copyright (c) 1999-2001, Oracle Corporation Japan. All rights reserved. */

-- Sample Oracle Portlet for Oracle Portal 3.0
-- Usage: SQL> @oracle_portlet <PROVIDER_SCHEMA>
-- Example: SQL> @oracle_portlet scott
-- 2001 08/15 by TH

set verify off
set define on

-- |[gbgEvoC_̃pbP[W쐬XL[}𓮓IɎw
undefine PROVIDER_SCHEMA
define PROVIDER_SCHEMA=&&1

-- |[gbgpbP[ẂuORACLE_PORTLETv
undefine PORTLET_PACKAGE
define PORTLET_PACKAGE=ORACLE_PORTLET

create or replace package &&PROVIDER_SCHEMA..&&PORTLET_PACKAGE
is
-- LbVp萔̐ݒ
    CACHE_LEVEL_SYSTEM constant varchar2(10) := 'SYSTEM';
    CACHE_LEVEL_USER   constant varchar2(10) := 'USER';

-- e|[gbgɓKIDӂ
    PORTLET_ID constant integer := 2;
-- |[gbǵuOraclev
    PORTLET_NAME constant varchar2(55) := 'Oracle';
-- |[gbg̕\́uOraclev
    DEFAULT_TITLE constant varchar2(55) := 'Oracle';
-- |[gbg̃ftHg̃LbVL[
    DEFAULT_CACHE_KEY constant varchar2(1) := '0';

-- [U[vt@XXgAp̒萔⃌R[h̒`
-- [U[vt@XXgȀڍׂɂĂPDKQƂ̂
    PORTLET_PATH    constant varchar2(256)
    := 'oracle.portal.sample.portlet.&&PORTLET_PACKAGE';
    DOMAIN          constant varchar2(30) := lower('provider');
    SUBDOMAIN       constant varchar2(32) := lower('&&PORTLET_PACKAGE');
    ORACLE_PREF     constant varchar2(256) := PORTLET_NAME || '_ORACLE';
    BUTTON_ORACLE   constant varchar2(55) := '肤';
    BUTTON_BACK     constant varchar2(55) := '߂';

    PAGE_01 constant number := 201;
    PAGE_02 constant number := 202;

    function is_runnable
    (
       p_provider_id in integer,
       p_reference_path in varchar2
    )
    return boolean;

-- w肳ꂽ|[gbgɊւڍ׏Ԃ
    function get_portlet_info
    (
        p_provider_id in integer,
        p_language    in varchar2
    )
    return wwpro_api_provider.portlet_record;

-- |[^Ey[WɃ|[gbgǉ鎞Ɉxs
    procedure register
    (
        p_portlet_instance in wwpro_api_provider.portlet_instance_record
    );

-- |[^Ey[W|[gbg폜鎞Ɉxs
    procedure deregister
    (
        p_portlet_instance in wwpro_api_provider.portlet_instance_record
    );

-- |[gbgo͂HTMLԂ
-- HTML̓e|[^Ey[W̃|[gbgƂċ@\
    procedure show
    (
        p_portlet_record in out wwpro_api_provider.portlet_runtime_record
    );

-- tH[ŃTu~bgƎsB
-- \y[WID[U[vt@XXgAɕۑ
    procedure save_prefs
    (
        p_page_id        in varchar2,
        p_page_url       in varchar2,
        p_reference_path in varchar2,
        p_action         in varchar2,
        p_request        in varchar2 default null
    );
end &&PORTLET_PACKAGE;
/

show errors package &&PROVIDER_SCHEMA..&&PORTLET_PACKAGE;

create or replace package body &&PROVIDER_SCHEMA..&&PORTLET_PACKAGE
is
    function is_runnable
    (
       p_provider_id in integer,
       p_reference_path in varchar2
    )
    return boolean is
    begin
        if p_reference_path is null then
            if wwctx_api.is_logged_on then
                return true;
            else
                return false;
            end if;
        else
            return true;
        end if;
    end is_runnable;

    function get_portlet_info
    (
        p_provider_id in integer,
        p_language    in varchar2
    )
    return wwpro_api_provider.portlet_record is
        l_portlet wwpro_api_provider.portlet_record;
    begin
        l_portlet.timeout := null;
        l_portlet.timeout_msg := null;
        l_portlet.implementation_style :=
        wwpro_api_provider_registry.DATABASE_IMPL;
        l_portlet.implementation_owner := '&&PROVIDER_SCHEMA';
        l_portlet.implementation_name := '&&PORTLET_PACKAGE';
        l_portlet.api_version := wwpro_api_provider.API_VERSION_1;
        l_portlet.has_show_edit_defaults := false;
        l_portlet.has_show_preview := true;
        l_portlet.language := wwctx_api.get_nls_language;
        l_portlet.content_type := wwpro_api_provider.CONTENT_TYPE_HTML;
        l_portlet.id := PORTLET_ID;
        l_portlet.name := PORTLET_NAME;
        l_portlet.title := DEFAULT_TITLE;
        l_portlet.description := DEFAULT_TITLE;

        return l_portlet;
    end get_portlet_info;

    function get_prefs
    (
        p_reference_path in varchar2,
        p_language in varchar2
    )
    return varchar2
    is
        l_oracle_id number;
    begin
        begin
            l_oracle_id := wwpre_api_value.get_value_as_number(
                p_path => PORTLET_PATH || p_reference_path,
                p_name => ORACLE_PREF,
                p_level_type => wwpre_api_value.USER_LEVEL_TYPE,
                p_level_name => wwctx_api.get_user);
            exception
                when others then
                    l_oracle_id := null;
        end;

        if l_oracle_id is null then
            l_oracle_id := page_01;
        end if;

        return l_oracle_id;
    end;

    procedure register
    (
        p_portlet_instance in wwpro_api_provider.portlet_instance_record
    )
    is
    begin
        begin
            wwpre_api_name.create_path(p_path => PORTLET_PATH || p_portlet_instance.reference_path);
        exception when wwpre_api_name.duplicate_path_exception then
            null;
        end;

        wwpre_api_name.create_name(
            p_path => PORTLET_PATH || p_portlet_instance.reference_path,
            p_name => ORACLE_PREF,
            p_description => ORACLE_PREF,
            p_type_name => 'NUMBER',
            p_language => wwctx_api.get_nls_language);
    exception
        when others then
            raise;
    end register;

    procedure deregister
    (
        p_portlet_instance in wwpro_api_provider.portlet_instance_record
    )
    is
    begin
        begin
            wwpre_api_name.delete_path(PORTLET_PATH || p_portlet_instance.reference_path);
        exception
            when others then
                 null;
        end;
    end deregister;

    procedure save_prefs
    (
        p_page_id        in varchar2,
        p_page_url       in varchar2,
        p_reference_path in varchar2,
        p_action         in varchar2,
        p_request        in varchar2 default null
    )
    is
    begin
        wwpre_api_value.set_value_as_number(
            p_path => PORTLET_PATH || p_reference_path,
            p_name => ORACLE_PREF,
            p_level_type => wwpre_api_value.USER_LEVEL_TYPE,
            p_level_name => wwctx_api.get_user,
            p_value => to_number(p_page_id));

        owa_util.redirect_url(curl => p_page_url);
    end;

    procedure show_preview
    is
    begin
        htp.centeropen;
        htp.p('<BR><FONT COLOR=Red><STRONG>Ȃ̍̉^Ă݂܂?'
           || '</STRONG></FONT><BR>');
        htp.centerclose;
    end;

    procedure show_help
    (
        p_back_url in varchar2
    )
    is
    begin
        htp.centeropen;
        htp.p('<BR><FONT COLOR=Red><STRONG>'
           || 'wv̕\'
           || '</STRONG></FONT><P>'
           || '̉^肤Ƃł܂<P>');
        htp.p('<A HREF="' || p_back_url || '">NbNƌ̃y[Wɖ߂܂</A><P>');
        htp.centerclose;
    end;

    procedure show_about
    (
        p_back_url in varchar2
    )
    is
    begin
        htp.centeropen;
        htp.p('<BR><FONT COLOR=Red><STRONG>'
           || '|[gbg̃o[W⒘쌠\'
           || '</STRONG></FONT><P>'
           || ': Oracle Portlet Ver. 1.1 (Portal 3.0p)<BR>'
           || 'Copyright (c) 2000-2001, Oracle Corporation Japan. All rights reserved.<P>');
        htp.p('<A HREF="' || p_back_url || '">NbNƌ̃y[Wɖ߂܂</A><P>');
        htp.centerclose;
    end;

    procedure show_error
    is
    begin
        htp.centeropen;
        htp.p('<BR><FONT COLOR=Red><STRONG>ʂ̑JڏԂɈُ킪܂B</FONT><P>'
           || 'x̃|[gbgy[W폜AĔzuĉB'
           || '</STRONG><BR>');
        htp.centerclose;
    end;

    procedure show_page1
    (
        p_page_url in varchar2,
        p_reference_path in varchar2
    )
    is
    begin
        htp.centeropen;
        htp.p('<BR><FONT COLOR=Red><STRONG>Ȃ̍̉^Ă݂܂?'
           || '</STRONG></FONT><BR>');
        htp.formopen(curl => '&&PROVIDER_SCHEMA..&&PORTLET_PACKAGE..save_prefs');
        htp.formsubmit(cname => 'p_action', cvalue => BUTTON_ORACLE);
        htp.formhidden(cname => 'p_page_url', cvalue => p_page_url);
        htp.formhidden(cname => 'p_reference_path', cvalue => p_reference_path);
        htp.formhidden(cname => 'p_page_id', cvalue => page_02);
        htp.formclose;
        htp.centerclose;
    end;

    procedure show_page2
    (
        p_page_url in varchar2,
        p_reference_path in varchar2
    )
    is
        l_oracle_id binary_integer;
        l_oracle_today varchar2(255);
    begin
        dbms_random.seed(TO_CHAR(SYSDATE,'MM-DD-YYYY HH24:MI:SS'));
        l_oracle_id := mod(abs(dbms_random.random), 10);

        if l_oracle_id = 0 then
            l_oracle_today := 'ɋg';
        elsif l_oracle_id = 1 then
            l_oracle_today := 'g';
        elsif l_oracle_id = 2 then
            l_oracle_today := 'g';
        elsif l_oracle_id = 3 then
            l_oracle_today := 'g';
        elsif l_oracle_id = 4 then
            l_oracle_today := 'g';
        elsif l_oracle_id = 5 then
            l_oracle_today := 'K^ƕs^̂͂';
        elsif l_oracle_id = 6 then
            l_oracle_today := '';
        elsif l_oracle_id = 7 then
            l_oracle_today := '';
        elsif l_oracle_id = 8 then
            l_oracle_today := 'ɋ';
        elsif l_oracle_id = 9 then
            l_oracle_today := '傤';
        else
            l_oracle_today := 'NĂ̂?';
        end if;

        htp.centeropen;
        htp.p('<BR><STRONG>Ȃ̍̉^...<P><FONT COLOR=Red><BLINK>'
           || l_oracle_today || '</BLINK></FONT></STRONG><BR>');
        htp.formopen(curl => '&&PROVIDER_SCHEMA..&&PORTLET_PACKAGE..save_prefs');
        htp.formsubmit(cname => 'p_action', cvalue => BUTTON_BACK);
        htp.formhidden(cname => 'p_page_url', cvalue => p_page_url);
        htp.formhidden(cname => 'p_reference_path', cvalue => p_reference_path);
        htp.formhidden(cname => 'p_page_id', cvalue => page_01);
        htp.formclose;
        htp.centerclose;
    end;

    procedure show_page3
    (
        p_page_url in varchar2,
        p_reference_path in varchar2,
        p_language in varchar2
    )
    is
        l_oracle_id number;
        l_oracle_today varchar2(55);
        l_oracle_next binary_integer;
    begin
        l_oracle_id := get_prefs(p_reference_path => p_reference_path,
                                 p_language => p_language);

        if l_oracle_id = 0 then
            l_oracle_today := 'ɋg';
        elsif l_oracle_id = 1 then
            l_oracle_today := 'g';
        elsif l_oracle_id = 2 then
            l_oracle_today := 'g';
        elsif l_oracle_id = 3 then
            l_oracle_today := 'g';
        elsif l_oracle_id = 4 then
            l_oracle_today := 'g';
        elsif l_oracle_id = 5 then
            l_oracle_today := 'K^ƕs^̂͂';
        elsif l_oracle_id = 6 then
            l_oracle_today := '';
        elsif l_oracle_id = 7 then
            l_oracle_today := '';
        elsif l_oracle_id = 8 then
            l_oracle_today := 'ɋ';
        elsif l_oracle_id = 9 then
            l_oracle_today := '傤';
        else
            l_oracle_today := 'NĂ̂?';
        end if;

        dbms_random.seed(TO_CHAR(SYSDATE,'MM-DD-YYYY HH24:MI:SS'));
/*
    4ŝ悤ɑO̐肢ƏɌʂقȂ悤ɂĂȂƁALbVɗL
    ȂĂ܂BƃuEUɕ\HTMLɓŁARusave_prefsvɑ
    up_page_idvɓɂȂĂ܂AxĂS^ɂȂĂ܂B
*/
        loop
            l_oracle_next := mod(abs(dbms_random.random), 10);
            exit when l_oracle_next <> l_oracle_id;
        end loop;

        if (l_oracle_id = page_01) or (l_oracle_id = page_02) then
            htp.centeropen;
            htp.p('<BR><FONT COLOR=Red><STRONG>Ȃ̍̉^Ă݂܂?'
               || '</STRONG></FONT><BR>');
            htp.formopen(curl => '&&PROVIDER_SCHEMA..&&PORTLET_PACKAGE..save_prefs');
            htp.formsubmit(cname => 'p_action', cvalue => BUTTON_ORACLE);
            htp.formhidden(cname => 'p_page_url', cvalue => p_page_url);
            htp.formhidden(cname => 'p_reference_path', cvalue => p_reference_path);
            htp.formhidden(cname => 'p_page_id', cvalue => to_char(l_oracle_next));
            htp.formclose;
            htp.centerclose;
        else
            htp.centeropen;
            htp.p('<BR><STRONG>Ȃ̍̉^...<P><FONT COLOR=Red><BLINK>'
               || l_oracle_today || '</BLINK></FONT></STRONG><BR>');
            htp.formopen(curl => '&&PROVIDER_SCHEMA..&&PORTLET_PACKAGE..save_prefs');
            htp.formsubmit(cname => 'p_action', cvalue => BUTTON_ORACLE);
            htp.formhidden(cname => 'p_page_url', cvalue => p_page_url);
            htp.formhidden(cname => 'p_reference_path', cvalue => p_reference_path);
            htp.formhidden(cname => 'p_page_id', cvalue => to_char(l_oracle_next));
            htp.formclose;
            htp.centerclose;
        end if;
    end;

    procedure show
    (
        p_portlet_record in out wwpro_api_provider.portlet_runtime_record
    )
    is
        l_oracle_id varchar2(55);
    begin
        if not is_runnable(p_provider_id => p_portlet_record.provider_id,
                           p_reference_path => p_portlet_record.reference_path) then
            p_portlet_record.caching_level := null;
            p_portlet_record.caching_key := null;

            wwerr_api_error.add(DOMAIN, SUBDOMAIN, 'securityerr', PORTLET_NAME || '.show'); 
            raise wwpro_api_provider.PORTLET_SECURITY_EXCEPTION;
        end if;

        l_oracle_id := get_prefs(p_reference_path => p_portlet_record.reference_path,
                                 p_language => p_portlet_record.language);

        if p_portlet_record.caching_level = CACHE_LEVEL_SYSTEM then
            if l_oracle_id is not null then
                p_portlet_record.caching_level := CACHE_LEVEL_USER;
                p_portlet_record.caching_key := l_oracle_id;
            else
                return;
            end if;
        elsif p_portlet_record.caching_level = CACHE_LEVEL_USER then
            if p_portlet_record.caching_key <> l_oracle_id then
                p_portlet_record.caching_key := l_oracle_id;
            else
                return;
            end if;
        elsif p_portlet_record.caching_level is null then
            if p_portlet_record.caching_key is not null then
                p_portlet_record.caching_level := CACHE_LEVEL_USER;
                p_portlet_record.caching_key := l_oracle_id;
            else
                p_portlet_record.caching_level := CACHE_LEVEL_SYSTEM;
                p_portlet_record.caching_key := l_oracle_id;
            end if;
        else
            p_portlet_record.caching_level := CACHE_LEVEL_SYSTEM;
            p_portlet_record.caching_key := l_oracle_id;
        end if;

        if p_portlet_record.exec_mode = wwpro_api_provider.MODE_SHOW then
            if p_portlet_record.has_title_region then
                wwui_api_portlet.draw_portlet_header(
                    p_provider_id       => p_portlet_record.provider_id,
                    p_portlet_id        => p_portlet_record.portlet_id,
                    p_title             => DEFAULT_TITLE,
                    p_has_details       => false,
                    p_has_edit          => false,
                    p_has_help          => true,
                    p_has_about         => true,
                    p_back_url          => p_portlet_record.page_url,
                    p_referencepath     => p_portlet_record.reference_path);
            end if;

            wwui_api_portlet.open_portlet(p_has_border => p_portlet_record.has_border);
/*
    y[WIDɉāA\y[W(ĂяovV[W)ύX
    ɂăy[W̑Jڂs
*/
            if l_oracle_id = page_01 then
                show_page1(p_page_url => p_portlet_record.page_url,
                           p_reference_path => p_portlet_record.reference_path);
            elsif l_oracle_id = page_02 then
                show_page2(p_page_url => p_portlet_record.page_url,
                           p_reference_path => p_portlet_record.reference_path);
            else
                show_error;
            end if;
/*
    Ȃ7s3sƓꊷƁAʑJڂɌʂ\

                show_page3(p_page_url => p_portlet_record.page_url,
                           p_reference_path => p_portlet_record.reference_path,
                           p_language => p_portlet_record.language);
*/
            wwui_api_portlet.close_portlet;
        elsif p_portlet_record.exec_mode = wwpro_api_provider.MODE_PREVIEW then
            show_preview;
        elsif p_portlet_record.exec_mode = wwpro_api_provider.MODE_SHOW_HELP then
            show_help(p_portlet_record.back_page_url);
        elsif p_portlet_record.exec_mode = wwpro_api_provider.MODE_SHOW_ABOUT then
            show_about(p_portlet_record.back_page_url);
        else
            raise wwpro_api_provider.PORTLET_EXECUTION_EXCEPTION;
        end if;
    end show;
end &&PORTLET_PACKAGE;
/

show errors package body &&PROVIDER_SCHEMA..&&PORTLET_PACKAGE;
grant execute on &&PROVIDER_SCHEMA..&&PORTLET_PACKAGE to public;
commit;
exit
